// Copyright (C) 2011 Nico Piatkowski <nico.piatkowski@tu-dortmund.de>, All rights reserved 
#ifndef InferenceEngine_H
#define InferenceEngine_H

#include "Model.h"
#include "DataLayer/ObservationSet.h"

template <class T>
class InferenceEngine{

	public:
		virtual T* getLogProps()    = 0;
		virtual T* getLogPropsGPU() = 0;

		virtual Model<T>* getModel() = 0;
		virtual void computeMarginals(ObservationSet<T>*) = 0;
		virtual unsigned int* computeMaxPropAssignment(ObservationSet<T>*) = 0;
		virtual unsigned int getGPUMemUsage() = 0;
		virtual void disableGradient() = 0;
		virtual T* getExpectations() = 0;
};
#endif
