// Copyright (C) 2011 Nico Piatkowski <nico.piatkowski@tu-dortmund.de>, All rights reserved 
#ifndef LinearModelConfig_H
#define LinearModelConfig_H

#include <vector_types.h>
#include "DataLayer/ParameterDescriptor.h"

template<class T>
struct LinearModelConfig{

	//unsigned int blockSize;
	//unsigned int subBlockSize;
	unsigned int structureCount;
	unsigned int labelCount;

	unsigned int structureSizesAlloc;
	unsigned int structMapAlloc;
	unsigned int nodeMarginalsAlloc;
	unsigned int edgeMarginalsAlloc;
	unsigned int parameterAlloc;
	unsigned int parameterMapAlloc;
	unsigned int nodeMapAlloc;
	unsigned int observationAlloc;
	unsigned int attStateMapAlloc;
	unsigned int attributeObservedIdxAlloc;
	unsigned int attributeObservedAlloc;
	unsigned int countAlloc;
	unsigned int valuesAlloc;
	unsigned int expectAlloc;

	unsigned int* structureSizes;
	ParameterDescriptor* parMap;
	unsigned int* structMap;
	unsigned int* nodeMap;
	int2* attStateMap;
	int2* attributeObservedIdx;
	int2* attributeObserved;
	unsigned int* obs;
	unsigned int* counts;

	T* parameter;
	T* nMarg;
	T* eMarg;
	T* values;
	T* expect;
	T* gradPrt;
};

#endif
