// Copyright (C) 2011 Nico Piatkowski <nico.piatkowski@tu-dortmund.de>, All rights reserved 
#ifndef MEMUTIL_H
#define MEMUTIL_H

template <class T>
inline void cudaRealloc(T** x, unsigned int &s, unsigned int b){
	if(s < b){
		if(s>0) cudaFree(*x);
		cudaMalloc((void**)x, b*sizeof(T));
		s = b;
	}
};

void* myRealloc(void* p, size_t s){
	free(p);
	void* q = malloc(s);
	return q;
}

void* myMalloc(size_t s){
	void* q = malloc(s);
	return q;
}

template <class T> void clearGPU(T*, unsigned int);

#endif

