// Copyright (C) 2011 Nico Piatkowski <nico.piatkowski@tu-dortmund.de>, All rights reserved 
#ifndef STRTOKENIZER_H
#define STRTOKENIZER_H

#include <string>
#include <vector>

using namespace std;

class strtokenizer {
	protected:
		vector<string*> tokens;
		int idx;
		string* empty;

	public:

		strtokenizer(string* str, string seperators = "\t"){
			empty = new string();
			parse(str, seperators);
		}

		~strtokenizer(){
			delete empty;
		}

		void parse(string* str, string seperators){
			int n = str->length();
			int start, stop;
    
			start = str->find_first_not_of(seperators);
			while (start >= 0 && start < n){
				stop = str->find_first_of(seperators, start);
				if (stop < 0 || stop > n){
					stop = n;
				}
	
				tokens.push_back(new string(str->substr(start, stop - start)));
				start = str->find_first_not_of(seperators, stop + 1);
			}
    
			start_scan();
		}

		int count_tokens(){
			return tokens.size();
		}

		void start_scan(){
			idx = 0;
		}

		string* next_token(){
			if(idx >= 0 && idx < tokens.size()){
				return tokens[idx++];
			}else{
				return empty;
			}
		}

		string* token(int i){
			if(i >= 0 && i < tokens.size()){
				return tokens[i];
			}else{
				return empty;
			}
		}
};
#endif
